;************************************************
;LEKCJA   9	- WYWIETLACZ ALFANUMERYCZNY LCD
;PRZYKAD 2	- INSTRUKCJE STERUJCE
;************************************************

	LJMP	START
	ORG	100H
START:

	MOV	R0,#LCDWC	;adres wpisu instrukcji
	MOV	R1,#LCDRC	;adres odczytu stanu

	MOV	A,#1		;kasuj dane wywietlacza
	ACALL	WRITE

	MOV	A,#0FH		;wcz wywietlacz,kursor
	ACALL	WRITE		;i mruganie kursora

	MOV	A,#06H		;ustaw kierunek
	ACALL	WRITE		;przesuwania si kursora

	INC	R0		;adres wpisu danych
	MOV	DPTR,#TEXT	;adres tekstu

WRITE_TXT:
	CLR	A		;pobranie kolejnego
	MOVC	A,@A+DPTR	;znaku tekstu
	JZ	TEXT_END	;bajt=0 - koniec tekstu

	ACALL	WRITE		;wpisanie na wywietlacz
	INC	DPTR		;modyfikacja adresu
				;pobrania kolejnego znaku
	SJMP	WRITE_TXT	;pobierz kolejny znak

TEXT_END:
	DEC	R0		  ;adres wpisu instrukcji
	MOV	DPTR,#KEY_COD ;adres tabeli kodowania
				  ;klawiszy

LOOP:			;ptla reakcji na klawisze

	LCALL	WAIT_KEY	;pobierz klawisz

	CJNE	A,#0DH,NO_DOWN		;czy klawisz 'v'
DOWN:				;klawisz 'v' (w d)
	MOVX	A,@R1
	JB	ACC.7,DOWN	;oczekiwanie na BUSY=0
	MOVX	A,@R1		;odczyt adresu z LCD
	CPL	ACC.6		;zmiana linii 1<->2
	SETB	ACC.7		;znacznik rozkazu
	ACALL	WRITE		;ustaw nowy adresu
	SJMP	LOOP

NO_DOWN:
	MOV	R2,A		;zapamitaj klawisz
	MOVC	A,@A+DPTR	;przekoduj klawisze
				;na instrukcje
	JZ	WRITE_DAT	;0-klawisz jako dane

	ACALL	WRITE		;wysanie instrukcji
	SJMP	LOOP

WRITE_DAT:			;wpisz znak na LCD
	MOV	A,R2		;odtwrz klawisz
	ADD	A,#30H		;modyfikuj jako znak
	INC	R0		;adres wpisu danych
	ACALL	WRITE		;wpisanie znaku na LCD
	DEC	R0		;adres wpisu instrukcji
	SJMP	LOOP

;**************************************
;Podprogram wpisu danych lub instrukcji
;na wywietlacz LCD
;Zakada prawidowe adresy w R0 i R1

WRITE:
	MOV	R2,A		;przechowanie danych
BUSY:
	MOVX	A,@R1		;odczyt stanu
	JB	ACC.7,BUSY	;oczekiwanie na BUSY=0
	MOV	A,R2		;odtworzenie danych
	MOVX	@R0,A		;wysanie danych
	RET

;**************************************
;Tabela przekodowania numeru klawisza
;na instrukcj, 0->klawisz jako znak
KEY_COD:
	DB	0,0,0			;0,1,2
	DB	0,18H,0			;3,4,5
	DB	1CH,0,0			;6,7,8
	DB	0,10H,14H		;9,<,>
	DB	02H,0,06H		;^,v,Esc
	DB	07H			;Enter

;**************************************
TEXT:
	DB	'"MicroMade"  Systemy'
	DB	' Mikroprocesorowe   '
	DB	' ul. Sikorskiego 33 '
	DB	'  64-920 PILA       ',0
