;************************************************
;LEKCJA  12	- SYSTEM PRZERWA 8051
;PRZYKAD 1	- TIMERY
;************************************************

LED	EQU	P1.7

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	1	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;50[ms] = 50 000[S]*(11.0592[MHz]/12) =
;	= 46 080 cykli = 180 * 256
TH0_SET		EQU	256-180
TL0_SET		EQU	0
;**************************************

	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH
	MOV	TH0,#TH0_SET		;TH0 na 50ms
	DJNZ	ACC,NO_1SEK		;czy mina 1 sek

	CPL	LED		;mruganie diody TEST
	MOV	A,#20		;odczekaj kolejny czas
				;20*50ms=1s
NO_1SEK:
	RETI

;**************************************
	ORG	100H
START:

	MOV	TMOD,#TMOD_SET		;Timer 0 liczy czas
	MOV	TH0,#TH0_SET		;Timer 0 na 50ms
	MOV	TL0,#TL0_SET
	SETB	TR0		;start Timera 0
	MOV	A,#20		;odczekaj czas 20*50ms=1s

	SETB	EA		;wcz zezwolenie oglne
				;na przerwania
	SETB	ET0		;wcz zezwolenie na
				;przerwanie od Timera 0

	SJMP	$		;koniec pracy
				;programu gwnego
