;************************************************
;LEKCJA  12	- SYSTEM PRZERWA 8051
;PRZYKAD 4 - PRIORYTETY PRZERWA
;************************************************

LED		EQU	P1.7		
SEG_ON		EQU	P1.6	;wczenie wyw.7-segm.

;******* Pami wewntrzna RAM ********
DISPLAY		EQU	30H	;pami danych dla wyw.
LEDY	EQU	DISPLAY+6	;pami danych dla diod
TIME	EQU	LEDY+1		;licznik czasu mrugania

STOS	EQU	60H

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	1	;MOD (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	1	;MOD (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

TH1_SET		EQU	256-4	;czas 4*256 = 1024 cykle
				;= ok.1ms

;************** MACRA *****************
BANK0	MACRO		;ustawienie banku 0 rejestrw
	CLR	RS0	;(z banku 1)
	MACEND

BANK1	MACRO		;ustawienie banku 1 rejestrw
	SETB	RS0	;(z banku 0)
	MACEND
;**************************************

	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH
	JNB	TF0,$		;oczekiwanie przez peen
				;okres timera - ok.71ms
	CLR	TF0
	DJNZ	TIME,NO_1SEK
	MOV	TIME,#7
	CPL	LED
NO_1SEK:
	RETI

;********* Przerwanie Timer 1 *********
	ORG	1BH
	PUSH	PSW
	PUSH	ACC
	BANK1			;uycie banku 1 rejestrw

	MOV	TH1,#TH1_SET  ;ustawienie TH1 na 1ms

	SETB	SEG_ON		;wyczenie wskanika

	MOV	A,R3		;aktualny wskanik (1z8)
	MOVX	@R1,A		;wpisz do bufora wyboru

	INC	R1		;adres bufora danych
	MOV	A,@R0		;dane dla wskanika
	CJNE	R3,#40H,SEG	;czy 7 wskanik
	SJMP	LEDS		;tak-diody-nie ma zamiany
SEG:
	ACALL	GET_COD7	;zamiana danych na kod
LEDS:
	MOVX	@R1,A		;wpisanie kodu segmentw

	CLR	SEG_ON		;wczenie wskanika
	DEC	R1		;adres bufora wyboru

	MOV	A,R3
	RL	A		;nastpny wskanik (1z8)
	MOV	R3,A
	INC	R0		;adres danych dla
				;nastpnego wskanika

	DJNZ	R2,INT_END	;czy ostatni wskanik
				;tak - ustaw dane dla 1
	MOV	R0,#DISPLAY	;adres danych
	MOV	R3,#1		;wybr wskanika-kod 1z8
	MOV	R2,#7		;liczba wskanikw

INT_END:			;zakoczenie przerwania
	POP	ACC
	POP	PSW
	RETI

;**************************************
GET_COD7:
	ANL	A,#0FH		;tabela kodw 0..15
	INC	A		;ominicie rozkazu RET
	MOVC	A,@A+PC		;pobranie kodu z tabeli
	RET

COD_7SEG:
	DB	03FH		;kod znaku 0
	DB	006H		;kod znaku 1
	DB	05BH		;kod znaku 2
	DB	04FH		;kod znaku 3
	DB	066H		;kod znaku 4
	DB	06DH		;kod znaku 5
	DB	07DH		;kod znaku 6
	DB	007H		;kod znaku 7
	DB	07FH		;kod znaku 8
	DB	06FH		;kod znaku 9

	DB	000H		;kod pusty (10)
	DB	000H		;kod pusty (11)
	DB	000H		;kod pusty (12)
	DB	000H		;kod pusty (13)
	DB	000H		;kod pusty (14)
	DB	000H		;kod pusty (15)

;**************************************
	ORG	100H
START:
	MOV	SP,#STOS

	MOV	DISPLAY,#6		;wpisanie kolejnych
	MOV	DISPLAY+1,#5		;cyfr na wskaniki
	MOV	DISPLAY+2,#4
	MOV	DISPLAY+3,#3
	MOV	DISPLAY+4,#2
	MOV	DISPLAY+5,#1

	BANK1			;rejestry banku1
				;dla obsugi wywietlacza
	MOV	R0,#DISPLAY	;adres danych
	MOV	R1,#CSDS+7	;adres wyboru wskanika
				;z moliwoci zamiany na
				;adres danych wskanika
	MOV	R2,#7		;liczba wskanikw
	MOV	R3,#1		;wybr wskanika-kod 1z8
	BANK0

	MOV	TMOD,#TMOD_SET		;Timery licz czas
	MOV	TH1,#TH1_SET		;Timer 1 na 1ms
	CLR	A
	MOV	TL1,A
	MOV	TH0,A			;Timer 0 na ok.71ms
	MOV	TL0,A
	SETB	TR0			;start timerw
	SETB	TR1
	MOV	TIME,#7

	SETB	EA		;zezwolenie na przerwanie
	SETB	ET0		;od timerw
	SETB	ET1

	MOV	LEDY,#20H	;dioda 'ERror'

	LCALL	LCD_CLR
	MOV	DPTR,#TEXT
	LCALL	WRITE_TEXT

LOOP:			;zmiana priorytetu przerwania
			;Timera 1

	LCALL	WAIT_ENT_ESC
	JNC	HIGH_PRIOR
	CLR	PT1		;Esc->niski prirytet
	MOV	LEDY,#20H	;dioda 'ERror'
	SJMP	LOOP

HIGH_PRIOR:
	SETB	PT1		;Enter->wysoki prirytet
	MOV	LEDY,#10H	;dioda 'OK'
	SJMP	LOOP

TEXT:
	DB	'ENTER -> T0 HP  '
	DB	'ESC   -> T0 LP ',0
