;************************************************
;LEKCJA  14	- PROGRAMOWA REALIZACJA TRANSMISJI
;PRZYKAD 2	- ODBIR
;************************************************

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	2	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16

;******* Transmisja Szeregowa *********
;Timer/Bit = Fosc[Hz] /12 /V[bod]
BIT_TIME	EQU	11059200/12/4800
T0_SET		EQU	256-BIT_TIME
T0_STRT		EQU	256-BIT_TIME/2
IN		EQU	INT0
;**************************************

	LJMP	START

;********* Przerwanie INT 0 ***********
	ORG	03H
	SETB	TR0		;wcz Timer 0
	CLR	EX0		;blokuj przerwanie INT0
	RETI

;********* Przerwanie Timer 0 *********
	ORG	0BH
	PUSH	PSW
	PUSH	ACC
	DJNZ	R2,NEXT
				;odebrano cay bajt
				;aktualnie trwa bit stopu
	CLR	TR0		;wycz Timer 0
	MOV	TL0,#T0_STRT ;ustawienia dla kolejnej
	MOV	R2,#10		;transmisji
	SETB	EX0		

	MOV	A,R7		;odebrany bajt na LCD
	LCALL	WRITE_DATA

	POP	ACC
	POP	PSW
	RETI

NEXT:				;kolejny bit transmisji
	MOV	C,IN		;pobierz bit
	MOV	A,R7
	RRC	A		;dopisz do poprzednich
	MOV	R7,A
	POP	ACC
	POP	PSW
	RETI

;***************************************
	ORG	100H
START:

	LCALL	LCD_CLR

	MOV	TMOD,#TMOD_SET		;Timer 0 dla
	MOV	TH0,#T0_SET		;transmisji	
	MOV	TL0,#T0_STRT		;1/2 bitu startu
	MOV	R2,#10			;licznik bitw

	SETB	EA		;wcz przerwania
	SETB	ET0		;od Timera 0
	SETB	EX0		;i z wejcia INT0

	SJMP	$
