;************************************************
;LEKCJA  15	- STEROWNIK PRZERWA DSM-51
;PRZYKAD 4	- ODBIR RS-485
;************************************************

;********* Ustawienie TIMERw *********
;TIMER 0
T0_G	EQU	0	;GATE
T0_C	EQU	0	;COUNTER/-TIMER
T0_M	EQU	2	;MODE (0..3)
TIM0	EQU	T0_M+T0_C*4+T0_G*8
;TIMER 1
T1_G	EQU	0	;GATE
T1_C	EQU	0	;COUNTER/-TIMER
T1_M	EQU	0	;MODE (0..3)
TIM1	EQU	T1_M+T1_C*4+T1_G*8

TMOD_SET	EQU	TIM0+TIM1*16
TMOD_STRT	EQU	TMOD_SET+4		;licznik

;******* Transmisja Szeregowa *********
;Timer/Bit = Fosc[Hz] /12 /V[bod]
BIT_TIME	EQU	11059200/12/4800
T0_SET		EQU	256-BIT_TIME
T0_STRT		EQU	256-BIT_TIME/2
IN		EQU	P3.4

;**************************************
;rejestr B jako zestaw flag
;B.0	= 1	oczekiwanie na bit startu
;	  0	odbir kolejnych bitw

;**************************************
	LJMP	START

;********* Przerwanie Timer 0 *********
	ORG	0BH
	PUSH	PSW
	PUSH	ACC
	JBC	B.0,FIRST	;czy bit startu
	DJNZ	R2,NEXT		;czy kolejny bit

				;odebrano cay bajt
				;aktualnie trwa bit stopu
	SETB	B.0		;ustawienia dla kolejnej
	MOV	R2,#10		;transmisji
	MOV	TMOD,#TMOD_STRT
	MOV	TL0,#255
	MOV	TH0,#T0_STRT

	MOV	A,R7		;odebrany bajt na LCD
	LCALL	WRITE_DATA

	POP	ACC
	POP	PSW
	RETI

NEXT:				;kolejny bit transmisji
	MOV	C,IN		;pobierz bit
	MOV	A,R7
	RRC	A		;dopisz do poprzednich
	MOV	R7,A
	POP	ACC
	POP	PSW
	RETI

FIRST:				;odebrany bit startu
	MOV	TMOD,#TMOD_SET		;ustawienia dla
	MOV	TH0,#T0_SET		;kolejnych bitw
	POP	ACC
	POP	PSW
	RETI

;***************************************
	ORG	100H
START:

	LCALL	LCD_CLR

	MOV	TMOD,#TMOD_STRT		;Timer 0 dla bitu
	MOV	TH0,#T0_STRT		;startu
	MOV	TL0,#255
	MOV	R2,#10			;licznik bitw
	SETB	B.0		;czekaj na bit startu

	SETB	EA		;wcz przerwania
	SETB	ET0		;od Timera 0
	SETB	TR0		;start Timera

	SJMP	$
