;************************************************
;LEKCJA  16	- UKAD TRANSMISJI RWNOLEGEJ 8255
;PRZYKAD 2	- TRYB 0 - PORT C
;************************************************

;********** Ustawienie 8255 ***********
;PORT CA - wyjcie
;PC4=0 -> nadajnik podczerwieni wczony
;PORT CB - WEJCIE
;PC1=0 -> tor 1 przesonity
;PC2=0 -> tor 2 przesonity
;PC0(IPB)=impuls dodatni - zmiana w torze 1
;PC3(IPA)=impuls dodatni - zmiana w torze 2

PA_M	EQU	0	;TRYB 0..2
PA_D	EQU	0	;OUT->0, IN->1
PCA_D	EQU	0	;OUT->0, IN->1
PB_M	EQU	0	;TRYB 0..1
PB_D	EQU	0	;OUT->0, IN->1
PCB_D	EQU	1	;OUT->0, IN->1

PA	EQU	PA_M*4+PA_D*2+PCA_D
PB	EQU	PB_M*4+PB_D*2+PCB_D
SET_8255	EQU	80H+PA*8+PB

INT55	EQU	P1.1	;uaktywnienie przerwa 8255

;**************************************
SEG_ON EQU	P1.6	;wczenie wyw. 7-seg.

;rejestry z adresowaniem bitw
IMPULS EQU	20H	;flagi impulsw z PC0,PC3
IR	EQU	21H	;bajt do wczania nadajnika

;**************************************
	LJMP	START

;********* Przerwanie INT 1 ***********
	ORG	13H
	PUSH	ACC
	PUSH	PSW

	MOVX	A,@R1		;odczyt numeru przerwania
	ANL	A,#03H
	MOVX	@R1,A		;skasowanie przerwania

	CJNE	A,#3,INT_NO3
	CPL	IMPULS.5	;przerwanie IPB - TOR1
	SJMP	INT_END

INT_NO3:
	CJNE	A,#2,INT_END
	CPL	IMPULS.4	;przerwanie IPA - TOR2

INT_END:
	POP	PSW
	POP	ACC
	RETI	

;**************************************
	ORG	0100H
START:
	MOV	R0,#CS55D		;inicjalizacja 8255
	MOV	A,#SET_8255
	MOVX	@R0,A

	DEC	R0
	MOV	A,#11101111B		;wczenie nadajni-
	MOVX	@R0,A			;ka podczerwieni

	MOV	DPTR,#0FF00H+CSDS	;wybr wskanika
	MOV	A,#41H			;1 i 7(diody)
	MOVX	@DPTR,A

	MOV	DPTR,#0FF00H+CSDB	;zgaszenie
	MOV	A,#0H			;wskanikw
	MOVX	@DPTR,A
	CLR	SEG_ON

	MOV	IMPULS,#0	;zerowanie flag impulsw
	MOV	IR,#4*2		;sterowanie bitem PC4

;**************************************
	CLR	INT55		;uaktywnienie sterownika
				;na przerwania z 8255
	MOV	R1,#CSAD	;skasowanie przerwania
	MOVX	A,@R1		;z przetwornika A/C

	MOV	R1,#CSIC	;skasowanie przerwa
	CLR	A		;w sterowniku przerwa
	MOVX	@R1,A
	INC	A
	MOVX	@R1,A
	INC	A
	MOVX	@R1,A
	INC	A
	MOVX	@R1,A

	SETB	EA		;wczenie przerwa
	SETB	EX1		;z wejcia INT1

;**************************************
LOOP:
	MOVX	A,@R0		;odczyt portu C 8255
	ANL	A,#0FH		;wywietl 4 modsze bity
	ORL	A,IMPULS	;+flagi impulsw PC0,PC3
	MOVX	@DPTR,A

	JB	T1,IR_ON	;czy zmiana stanu
	JNB	IR.0,LOOP	;klawisza Enter

	CLR	IR.0		;tak-klawisz zwolniony
	SJMP	SET_IR		;wcz nadajnik

IR_ON:
	JB	IR.0,LOOP	;klawisz nacinity
	SETB	IR.0		;wycz nadajnik

SET_IR:
	INC	R0		;wczenie/wyczenie
	MOV	A,IR		;nadajnika podczerwieni
	MOVX	@R0,A
	DEC	R0

	SJMP	LOOP
